/* ============================================================
 * File  : tetrahedron.cpp
 * Author: Stephane Gibault
 * Date  : Sun Feb 4 2007
 * Description :
 *
 * 
 *  (C) 2007 by Stephane Gibault
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include <QtGui>
#include <QImageReader>
#include "mypainter.h"

mypainter::mypainter ( QWidget * parent )
    : QLabel(parent)
{
	this->setMouseTracking(true);
	this->setScaledContents(true);
	setAttribute(Qt::WA_NoSystemBackground);
	mydraw.load(":/new/prefix2/Interface/Theme/nullpixmap.png");
	mydraw = mydraw.scaled( 720, 576, Qt::IgnoreAspectRatio, Qt::FastTransformation );
	mydraw.fill(0);
	mycolor.setRed(255);
	mycolor.setGreen(255);
	mycolor.setBlue(255);
	mycolor.setAlpha(255);
	ptsize = 20;
	tool = 1;
}

void mypainter::mouseMoveEvent ( QMouseEvent * event )
{
    	if (event->buttons() & Qt::LeftButton) 
	{
		paint_x = event->x();
		paint_y = event->y();
		QPainter p;
		p.begin(&mydraw);
		p.setRenderHint(QPainter::Antialiasing,true);
		if ( tool == 1 )
		{
			QPen pen;
			pen.setWidth(ptsize);
			pen.setCapStyle(Qt::RoundCap);
			pen.setJoinStyle(Qt::RoundJoin);
			pen.setBrush(mycolor);
			p.setPen(pen);
			//p.drawPoint ( paint_x, paint_y );
			p.drawLine( lastPos.x(), lastPos.y(), paint_x, paint_y );
		}
		else
		{
			QPainter::CompositionMode mode = (QPainter::CompositionMode)2;
			p.setCompositionMode ( mode );
			p.setBackgroundMode(Qt::TransparentMode);
			QPen pen;
			pen.setWidth(ptsize);
			pen.setCapStyle(Qt::RoundCap);
			pen.setJoinStyle(Qt::RoundJoin);
			pen.setBrush(QColor(0,0,0,0));
			p.setPen(pen);
			//p.drawPoint ( paint_x, paint_y );
			p.drawLine( lastPos.x(), lastPos.y(), paint_x, paint_y );
		}
		p.end();

		this->repaint();
		lastPos = event->pos();
	}
}

void mypainter::mousePressEvent ( QMouseEvent * event ) 
{
    	if (event->buttons() & Qt::LeftButton) 
	{
		paint_x = event->x();
		paint_y = event->y();
		QPainter p;
		p.begin(&mydraw);
		p.setRenderHint(QPainter::Antialiasing,true);
		if ( tool == 1 )
		{
			QPen pen;
			pen.setWidth(ptsize);
			pen.setCapStyle(Qt::RoundCap);
			pen.setJoinStyle(Qt::RoundJoin);
			pen.setBrush(mycolor);
			p.setPen(pen);
			p.drawPoint ( paint_x, paint_y );
		}
		else
		{
			QPainter::CompositionMode mode = (QPainter::CompositionMode)2;
			p.setCompositionMode ( mode );
			p.setBackgroundMode(Qt::TransparentMode);
			QPen pen;
			pen.setWidth(ptsize);
			pen.setCapStyle(Qt::RoundCap);
			pen.setJoinStyle(Qt::RoundJoin);
			pen.setBrush(QColor(0,0,0,0));
			p.setPen(pen);
			p.drawPoint ( paint_x, paint_y );
		}
		p.end();

		this->repaint();
		lastPos = event->pos();
	}
}

void mypainter::paintEvent(QPaintEvent *)
{
	QPainter p;
	p.begin(this);
	p.drawPixmap ( 0, 0, img2fond );
	p.drawImage ( 0, 0, mydraw );
	p.end();
}

